﻿# Client .NET per i servizi di integrazione di RINew #

Breve guida per l'installazione e la configurazione del client .NET verso
i servizi di integrazione esposti da RINew.

## Installazione della libreria ##

_Nota per il manutentore dei documenti README: questa sezione deve essere sincronizzata_
_con il documento README per il client .NET verso i servizi di travaso dati._

Si suggerisce fortemente l'uso di NuGet per l'installazione dei client .NET,
dato che questo garantisce automaticamente un buon numero di vantaggi:

* __Gestione della versione della libreria__: Risulta immediato capire quale versione
  sia installata all'interno di un dato progetto.
* __Installazione delle dipendenze__: Un meccanismo insito in NuGet si occupa delle
  dipendenze e di eventuali azioni da eseguire in fase di installazione.
* __Gestione di futuri aggiornamenti__: NuGet si occuperà di aggiornare tutti
  i riferimenti e le eventuali nuove dipendenze.

Dato che i pacchetti RINA __non__ possono essere pubblicati sul repository pubblico
e ufficiale di NuGet, si suggerisce la creazione di un repository locale per
poter portare a termine la corretta installazione dei pacchetti.

Esistono diverse procedure online che spiegano come aggiungere un repository
NuGet locale ad una macchina di sviluppo; ad esempio, la seguente guida contiene
tutte le istruzioni necessarie:

[http://codurance.com/2015/05/04/creating-a-local-nuget-repository/]()

Supponendo di aver chiamato la cartella contenente il repository locale "MyNuGetPackages",
sarà necessario copiare dentro tale cartella tutti i pacchetti forniti nel kit
di installazione dei client .NET.

A questo punto, da Visual Studio occorre aprire la solution contenente il progetto
(o i progetti) su cui si desidera installare i client .NET. 

Su tali progetti, sarà necessario installare il pacchetto del client .NET 
attraverso l'opportuna maschera di NuGet, avendo l'accortezza di selezionare "MyNuGetPackages" 
come sorgente dati da cui estrarre i pacchetti. Finché non si sceglie correttamente la sorgente dati,
il pacchetto `RINA.RINew.IntegrationService.Client` non risulterà visibile.

Dopo aver installato il pacchetto, l'operazione di installazione del client .NET è conclusa.
Non resta che procedere con la relativa configurazione.

## Configurazione della libreria ##

Ciascuna implementazione ha una propria configurazione, la quale in genere si risolve passando
un certo numero di argomenti alla specifica implementazione da usare.

Il progetto di prova configura le due implementazioni usando Ninject.

### Implementazione MOCK ###

Il tipo corrispondente a questa implementazione è `RINA.RINew.IntegrationService.Client.MockIntegrationService`.

I parametri esposti dal suo costruttore sono:

* path: Il percorso dove sono memorizzati i file JSON con i dati di prova. Nel progetto di prova,
  i file JSON sono memorizzati dentro la cartella "Entities", alla radice del progetto.

### Implementazione REST ###

Il tipo corrispondente a questa implementazione è `RINA.RINew.IntegrationService.Client.StandardIntegrationService`.

I parametri esposti dal suo costruttore sono:

* log: Un'istanza del log applicativo. Può essere passato un log che non fa nulla, se desiderato.
* serviceUrl: L'indirizzo del servizio di integrazione.

## Uso della componente MOCK ##

### Struttura dei file JSON ###

Ciascun file JSON presenta alcune proprietà di testata, seguite da varie righe che rappresentano
i dati, nel caso di GetData, o gli override per le response, nel caso di SendData.

Le varie proprietà sono:

* EntityName: Il nome dell'entità del servizio di integrazione - "finalservice", ad esempio.
  Il file JSON deve essere nominato come il valore di questa proprietà.
* GetDataKey (solo per GetData): Il campo chiave dell'entità, o la colonna speciale del servizio di integrazione
  che viene restituita comunque, nonostante non sia stata richiesta (questo per emulare il meglio
  possibile il comportamento del servizio reale).
* GetDataItems (solo per GetData): Una lista di oggetti che saranno restituiti dal mock.
* SendDataKey (solo per SendData): Il campo chiave dell'entità che viene inviata.
* SendDataOverrides (solo per SendData): TODO!